//+------------------------------------------------------------------+
//|                                                     OpenTiks.mq4 |
//|                                        Copyright  2008, ZerkMax |
//|                                                      zma@mail.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, ZerkMax"
#property link      "zma@mail.ru"
#include       <common.mqh>
#define        MAXORDERS            1000

extern double ProfitExit = 0.5; //% profit exit
extern bool   bUseStopLevelForTS = True;
extern bool   bUseTPLevelFor = True;
extern int    InitialSL       = 1000;
extern double lot           = 0.01;
extern int    MagicNumber    = 777;
extern bool   PolLots        = True;
extern int    MaxOrders      =  1000;


double curprof;
bool exit,tickvalue;
int prevtime;
int TrailingStop;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----------------------- GENERATE MAGIC NUMBER AND TICKET COMMENT
//----------------------- SOURCE : PENGIE
   MagicNumber    = subGenerateMagicNumber(MagicNumber, Symbol(), Period());
   tickvalue = MarketInfo(Symbol(),MODE_TICKVALUE); 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  
  if(bUseStopLevelForTS)TrailingStop = MarketInfo(Symbol(),MODE_STOPLEVEL);

   CommentMe();

//----





   int i=0;
   int total = OrdersTotal();   
   for(i = 0; i <= total; i++) 
     {
      if(TrailingStop>0)  
       {                 
       OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
       if(OrderMagicNumber() == MagicNumber) 
         {
         TrailingStairs(OrderTicket(),TrailingStop);
         }
       }
      }
   double high  = iHigh(NULL,1,1);
   double low   = iLow(NULL,1,1);
   double close = iClose(NULL,1,1);
   double open  = iOpen(NULL,1,0);
   double P = (high+low+close)/3;
   
      double high2  = iHigh(NULL,5,1);
   double low2   = iLow(NULL,5,1);
   double close2 = iClose(NULL,5,1);
   double open2  = iOpen(NULL,5,0);
   double P2 = (high2+low2+close2)/3;
   
      double high3  = iHigh(NULL,15,1);
   double low3   = iLow(NULL,15,1);
   double close3 = iClose(NULL,15,1);
   double open3  = iOpen(NULL,15,0);
   double P3 = (high3+low3+close3)/3;
   
      double high4  = iHigh(NULL,30,1);
   double low4   = iLow(NULL,30,1);
   double close4 = iClose(NULL,30,1);
   double open4  = iOpen(NULL,30,0);
   double P4 = (high4+low4+close4)/3;
   
      double high5  = iHigh(NULL,60,1);
   double low5   = iLow(NULL,60,1);
   double close5 = iClose(NULL,60,1);
   double open5  = iOpen(NULL,60,0);
   double P5 = (high5+low5+close5)/3;
   
      double high6  = iHigh(NULL,240,1);
   double low6   = iLow(NULL,240,1);
   double close6 = iClose(NULL,240,1);
   double open6  = iOpen(NULL,240,0);
   double P6 = (high6+low6+close6)/3;
   
   double high7  = iHigh(NULL,1440,1);
   double low7   = iLow(NULL,1440,1);
   double close7 = iClose(NULL,1440,1);
   double open7  = iOpen(NULL,1440,0);
   double P7 = (high7+low7+close7)/3;


bool BuyOp1=false;
bool SellOp1=false;
bool BuyOp2=false;
bool SellOp2=false;
bool BuyOp3=false;
bool SellOp3=false;
bool BuyOp4=false;
bool SellOp4=false;
bool BuyOp5=false;
bool SellOp5=false;
bool BuyOp6=false;
bool SellOp6=false;
bool BuyOp7=false;
bool SellOp7=false;
bool Long = false;
bool Short = false;


      if (Bid>P) BuyOp1=true;
      if (Ask<P) SellOp1=true;
      if (Bid>P2) BuyOp2=true;
      if (Ask<P2) SellOp2=true;
      if (Bid>P3) BuyOp3=true;
      if (Ask<P3) SellOp3=true;
      if (Bid>P4) BuyOp4=true;
      if (Ask<P4) SellOp4=true;
      if (Bid>P5) BuyOp5=true;
      if (Ask<P5) SellOp5=true;      
      if (Bid>P6) BuyOp6=true;
      if (Ask<P6) SellOp6=true;      
      if (Bid>P7) BuyOp7=true;
      if (Ask<P7) SellOp7=true;
      
      if (BuyOp1 || BuyOp2 || BuyOp3 || BuyOp4 || BuyOp5 || BuyOp6 || BuyOp7) Long=True;
      if (SellOp1 || SellOp2 || SellOp3 || SellOp4 || SellOp5 || SellOp6 || SellOp7) Short=True;
      
exit=false;
if (curprof>=AccountEquity()*ProfitExit/100.0) {
exit=true;
}      
      
   if(Time[0] == prevtime) 
       return(0);
   prevtime = Time[0];
   if(!IsTradeAllowed()) 
     {
       prevtime = Time[1];
       return(0);
     }


   if (total < MaxOrders || MaxOrders == 0)
     {   
       if(Long)
        { 
         if (InitialSL!=0)
          {
          lot = lotsOptimized(TrailingStop*Point);
           OrderSend(Symbol(),OP_BUY,lot,Ask,3,Bid-(InitialSL*Point),Bid+(exit),"OpenTiks_Buy",MagicNumber,0,Green);
          }
         else
          {
          lot = lotsOptimized(TrailingStop*Point);
           OrderSend(Symbol(),OP_BUY,lot,Ask,3,0,0,"OpenTiks_Buy",MagicNumber,0,Green);
          }
        }
       if(Short)
        { 
         if (InitialSL!=0)
          {
          lot = lotsOptimized(TrailingStop*Point);
           OrderSend(Symbol(),OP_SELL,lot,Bid,3,Ask+(InitialSL*Point),Ask-(exit),"OpenTiks_Sell",MagicNumber,0,Red);
          } 
         else 
          {
          lot = lotsOptimized(TrailingStop*Point);
           OrderSend(Symbol(),OP_SELL,lot,Bid,3,0,0,"OpenTiks_Sell",MagicNumber,0,Red);
          }
        }
      }
   
//----
   return(0);
  } 
 
//+------------------------------------------------------------------+
void TrailingStairs(int ticket,int trldistance)
   {
    int Spred=Ask - Bid;
    if (OrderType()==OP_BUY)
      {
       if((Bid-OrderOpenPrice())>(Point*trldistance))
         {
          if(OrderStopLoss()<Bid-Point*trldistance || (OrderStopLoss()==0))
            {
             OrderModify(ticket,OrderOpenPrice(),Bid-Point*trldistance,OrderTakeProfit(),0,Green);
             if (PolLots)
             if (NormalizeDouble(OrderLots()/2,2)>MarketInfo(Symbol(), MODE_MINLOT))
               {
               OrderClose(ticket,NormalizeDouble(OrderLots()/2,2),Ask,3,Green);
               }
             else
               {
               OrderClose(ticket,OrderLots(),Ask,3,Green);
               }
            }
         }
       }
     else
       {
        if((OrderOpenPrice()-Ask)>(Point*trldistance))
          {
           if((OrderStopLoss()>(Ask+Point*trldistance)) || (OrderStopLoss()==0))
             {
              OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*trldistance,OrderTakeProfit(),0,Red);
             if (PolLots)
             if (NormalizeDouble(OrderLots()/2,2)>MarketInfo(Symbol(), MODE_MINLOT))
               {
               OrderClose(ticket,NormalizeDouble(OrderLots()/2,2),Bid,3,Green);
               }
             else
               {
               OrderClose(ticket,OrderLots(),Bid,3,Green);
               }
             }
          }
        }
    }
//----------------------------------------- COMMENT FUNCTION ----------------------------------------------------

int CommentMe()    //Comments out needed parameters on a chart
{
RefreshRates();
double Eq.CM = AccountEquity();
double Bal.CM = AccountBalance();
double Mar.CM = AccountMargin();
double Prof.CM = AccountProfit();
double Lev.CM = AccountLeverage();
double TV.CM = MarketInfo(Symbol(), MODE_TICKVALUE);
double Sprd.CM = MarketInfo(Symbol(), MODE_SPREAD);
double SWL.CM = MarketInfo(Symbol(), MODE_SWAPLONG);
double SWS.CM = MarketInfo(Symbol(), MODE_SWAPSHORT);
double STP.CM = MarketInfo(Symbol(),MODE_STOPLEVEL);



Comment("Account balance is ",DoubleToStr(Bal.CM,2),"\n",
        "Account equity is ",DoubleToStr(Eq.CM,2),"\n",
        "Account profit is ",DoubleToStr(Prof.CM,2),"\n",
        "Account margin is ",DoubleToStr(Mar.CM,2),"\n",
        "Account Leverage is ",DoubleToStr(Lev.CM,2),"\n",        
        "Tick Value is ",DoubleToStr(TV.CM,4),"\n",
        "Spread is ",DoubleToStr(Sprd.CM,0),"\n",
        "Swap Long is ",DoubleToStr(SWL.CM,4),"\n",
        "Swap Short is ",DoubleToStr(SWS.CM,4),"\n",
        "Trailing Stop is ",DoubleToStr(STP.CM,4),"\n",         
        "Current time is ",TimeToStr(TimeCurrent()));

return(0);
}
    
//----------------------- GENERATE MAGIC NUMBER BASE ON SYMBOL AND TIME FRAME FUNCTION
//----------------------- SOURCE   : PENGIE

int subGenerateMagicNumber(int Magic_Number, string symbol, int timeFrame)
{
   int isymbol = 0;
   if (symbol == "AUDCAD")       isymbol = 1;
   else if (symbol == "AUDCHF")  isymbol = 2;
   else if (symbol == "AUDJPY")  isymbol = 3;
   else if (symbol == "AUDDKK")  isymbol = 4;
   else if (symbol == "AUDNZD")  isymbol = 5;
   else if (symbol == "AUDPLN")  isymbol = 6;
   else if (symbol == "AUDSGD")  isymbol = 7;
   else if (symbol == "AUDUSD")  isymbol = 8;
   else if (symbol == "CADCHF")  isymbol = 9;
   else if (symbol == "CADJPY")  isymbol = 10;
   else if (symbol == "CHFCAD")  isymbol = 11;
   else if (symbol == "CHFJPY")  isymbol = 12;
   else if (symbol == "CHFSGD")  isymbol = 13;
   else if (symbol == "EURAUD")  isymbol = 14;
   else if (symbol == "EURCAD")  isymbol = 15;
   else if (symbol == "EURCHF")  isymbol = 16;
   else if (symbol == "EURDKK")  isymbol = 17;
   else if (symbol == "EURGBP")  isymbol = 18;
   else if (symbol == "EURHKD")  isymbol = 19;
   else if (symbol == "EURHUF")  isymbol = 20;
   else if (symbol == "EURJPY")  isymbol = 21;
   else if (symbol == "EURLVL")  isymbol = 22;
   else if (symbol == "EURNOK")  isymbol = 23;
   else if (symbol == "EURNZD")  isymbol = 24;
   else if (symbol == "EURPLN")  isymbol = 25;
   else if (symbol == "EURSEK")  isymbol = 26;
   else if (symbol == "EURSGD")  isymbol = 27;
   else if (symbol == "EURSKK")  isymbol = 28;
   else if (symbol == "EURUSD")  isymbol = 29;
   else if (symbol == "EURZAR")  isymbol = 30;
   else if (symbol == "GBPAUD")  isymbol = 31;
   else if (symbol == "GBPCAD")  isymbol = 32;
   else if (symbol == "GBPCHF")  isymbol = 33;
   else if (symbol == "GBPDKK")  isymbol = 34;
   else if (symbol == "GBPJPY")  isymbol = 35;
   else if (symbol == "GBPNOK")  isymbol = 36;
   else if (symbol == "GBPNZD")  isymbol = 37;
   else if (symbol == "GBPSEK")  isymbol = 38;
   else if (symbol == "GBPSGD")  isymbol = 39;
   else if (symbol == "GBPUSD")  isymbol = 40;
   else if (symbol == "GBPZAR")  isymbol = 41;
   else if (symbol == "NZDCAD")  isymbol = 42;
   else if (symbol == "NZDCHF")  isymbol = 43;
   else if (symbol == "NZDJPY")  isymbol = 44;
   else if (symbol == "NZDSGD")  isymbol = 45;
   else if (symbol == "NZDUSD")  isymbol = 46;
   else if (symbol == "SGDJPY")  isymbol = 47;
   else if (symbol == "USDCAD")  isymbol = 48;
   else if (symbol == "USDCHF")  isymbol = 49;
   else if (symbol == "USDCCK")  isymbol = 50;
   else if (symbol == "USDDKK")  isymbol = 51;
   else if (symbol == "USDHKD")  isymbol = 52;
   else if (symbol == "USDHRK")  isymbol = 53;
   else if (symbol == "USDHUF")  isymbol = 54;
   else if (symbol == "USDJPY")  isymbol = 55;
   else if (symbol == "USDLVL")  isymbol = 56;
   else if (symbol == "USDLTL")  isymbol = 57;
   else if (symbol == "USDMXN")  isymbol = 58;
   else if (symbol == "USDNOK")  isymbol = 59;
   else if (symbol == "USDPLN")  isymbol = 60;
   else if (symbol == "USDSEK")  isymbol = 61;
   else if (symbol == "USDSGD")  isymbol = 62;
   else if (symbol == "USDSKK")  isymbol = 63;
   else if (symbol == "USDZAR")  isymbol = 64;
   else if (symbol == "#AA")  isymbol = 65;
   else if (symbol == "#AXP")  isymbol = 66;
   else if (symbol == "#BA")  isymbol = 67;
   else if (symbol == "#C")  isymbol = 68;
   else if (symbol == "#DD")  isymbol = 69;
   else if (symbol == "#DIS")  isymbol = 70;
   else if (symbol == "#AIG")  isymbol = 71;
   else if (symbol == "#GE")  isymbol = 72;
   else if (symbol == "#GM")  isymbol = 73;
   else if (symbol == "#HD")  isymbol = 74;
   else if (symbol == "#HON")  isymbol = 75;
   else if (symbol == "#HPQ")  isymbol = 76;
   else if (symbol == "#IBM")  isymbol = 77;
   else if (symbol == "#VZ")  isymbol = 78;
   else if (symbol == "#INTC")  isymbol = 79;
   else if (symbol == "#JNJ")  isymbol = 80;
   else if (symbol == "#JPM")  isymbol = 81;
   else if (symbol == "#KO")  isymbol = 82;
   else if (symbol == "#MCD")  isymbol = 83;
   else if (symbol == "#MMM")  isymbol = 84;
   else if (symbol == "#MO")  isymbol = 85;
   else if (symbol == "#MRK")  isymbol = 86;
   else if (symbol == "#MSFT")  isymbol = 87;
   else if (symbol == "#PG")  isymbol = 88;
   else if (symbol == "#T")  isymbol = 89;
   else if (symbol == "#PFE")  isymbol = 90;
   else if (symbol == "#UTX")  isymbol = 91;
   else if (symbol == "#WMT")  isymbol = 92;
   else if (symbol == "#XOM")  isymbol = 93;
   else if (symbol == "Gold")  isymbol = 94;
   else if (symbol == "Silver")  isymbol = 95;
   else if (symbol == "#EP")  isymbol = 96;
   else if (symbol == "#ENQ")  isymbol = 97;
   else if (symbol == "#YM")  isymbol = 98;
   else if (symbol == "#CL")  isymbol = 99;
   else if (symbol == "#NG")  isymbol = 100;
   else if (symbol == "#W")  isymbol = 101;
   else if (symbol == "#C")  isymbol = 102;
   else if (symbol == "#S")  isymbol = 103;
   else                          isymbol = 104;
   if(isymbol<10) Magic_Number = MagicNumber * 10;
   return (StrToInteger(StringConcatenate(MagicNumber, isymbol, timeFrame)));
   
}
//+------------------------------------------------------------------+    